#include <stdio.h>
#define CONFIG_NAME "rsz2.cfg"
#define FIRST_PRINT -2L
#define HEADER_PRINT -1L
#define END_PAGE -3L
#ifndef  BLOCK
//#include <graph.h>
#include <key_asm.h>

#define Start_Video_Buf 0xA000     //砫    
#define Video_Port      0x03CE     //  ࠡ饣  ஬
#define Video_Color     0x03C4     //  ࠡ饣  梥⮬
#define Get_Interrupt   0x0035     //㭪 DOS 祭 뢠
#define Set_Interrupt   0x0025     //㭪 DOS ⠭ 뢠
#define Tabl_Sim_Graph  0x001F     //  ᮤঠ騩 㪠⥫
                                   // ⠡ ᪨ ᨬ
#define Va_Str_Buf      0x0090     //   va_ 㭪権
#define Line_Next_Col   0x0050     //⢮  室  室
                                   //    ᫥ ப
#define Set_Video_Mode  0x0000     //㭪 BIOS_10  ⠭ ࠡ
                                   //ᯫ
#define STRING_LEN 255
 //  ୮ ப
#define FIELD_IN 30
 //     
#define EDITS 0x02
#define SHOWS 0x01

#define YES 0x01
#define NO 0x00

#define  MAXY  349     //ᨬ쭮 祭 ᥫ  ⨪
#define  XORI   0x1F    // 
#define  ANDI   0x0F    //㣠  

#define  H_ELP    0x00  //뢮  ᪠
#define  E_RROR   0x01  //뢮  訡
#define  W_ARNING 0x02  //뢮  ।०

#define NO_SIM 100
// typedef  void ( *PRNFUN )(char *,int *,int);
typedef  void ( far *DOPINPUTFUN )(char far *, short *,KEY *);
typedef  char ( far *DOPEDITFUN )(char far *, int, int);
typedef  char ( far *CORRECTFUN )(char far *, KEY, int);
typedef  int ( far *COMPAREFUN )(char far *, char far *);
typedef  int ( far *LONGFUN )(long);
typedef  int ( far *PRINTFUN )(long,int *);
	  //     , ⠭ ப
typedef  void ( far *STRFUN )( char far *,int ,int, long);
typedef  void ( far *FUN )( void );       //뢠 㪠⥫  㭪
typedef  void ( far *FUN_POINT )( void ); //뢠 㪠⥫  㭪
// 㭪 ࠡ⪨  :
typedef void (huge *TEXT_FUN2) (int,int,int,long);

//  ⨯  ᠭ  祭
typedef unsigned char COLOR;        // ।塞 ⨯ 梥
typedef unsigned char MODE;         // ।塞 ⨯  ०

/*****               ࠧ                    *****/
typedef struct                        //  ࠦ
               {
	         int X1, Y1,               // 孨 㣮 
	             X2, Y2;               //ࠢ   㣮 
	       }BLOCK;

/*****                                    *****/
typedef struct
               {
	          int  x1,y1,x2,y2;     //  ᪠
                  char far *title;
                  char far *text; //  ᪠
               } HELP;

struct MENU
       {  int x1, y1,  // 孨 㣮 
	      x2, y2;  // ࠢ 㣮 
          int kol;     //⢮ ⮢  
          char far *keys;  //ப   
       };

struct VID
       {  int x1, y1,  // 孨 㣮 
	      x2, y2;  // ࠢ 㣮 
          int kol;     //⢮ ⮢  
          char far *title; //  롮
          char far *keys;  //ப   
       };

struct VIDI
       {  int x1, y1,  // 孨 㣮 
	      x2, y2;  // ࠢ 㣮 
	  int kol;     //⢮ ⮢  
	  char far *title; //  롮
	  KEY far *keys;  //ப   
       };

struct CASE
       {  int   x1, y1, //孨  㣮  ᪠
                x2, y2; // ࠢ 㣮  ᪠
          COLOR color1, // ⥪ 
		color2, // 롮  㭪
                zam;    //㡫஢ 䫠 롮 (   ESC )
	  char  far *name; // 㭪 
          char  far *help; // ᪠
          FUN       sf; //⥫  㭪 ࠡ⪨  㭪
       };

struct CASEI
       {  int   x1, y1, //孨  㣮  ᪠
		x2, y2; // ࠢ 㣮  ᪠
	  COLOR color1, // ⥪ 
		color2, // 롮  㭪
		zam;    //㡫஢ 䫠 롮 (   ESC )
	  char far *name; // 㭪 
	  int   help_x,
		help_y1,
		help_y2;
	  char far *Data;
	  char far *help; // ᪠
	  FUN       sf; //⥫  㭪 ࠡ⪨  㭪
       };

//////////////////////////////////////////////////////////////////
 // ..㣮 - +  -  X  Y
struct WINDOW {     // ࠭筮 
 int x1,y1,x2,y2;   // 
 char itemsx;       // - ⮢  ਧ⠫
 int itemsy;        // - ⮢  ⨪
 char titley;        //   ᫮ ப 
 int far *Line;     // a⥫   ࠧ⪨ :
                    // Line[0] -- Line[itemsx-1] - ࠧ ⮫殢
 char UpStep;   //.-࠭⥫ ᢥ
 char DownStep; //.-࠭⥫ ᭨
 char LeftStep; //.-࠭⥫ ᫥
 char FieldY; //ਭ   Y
 char far *Title;      //   
 char far * far * Names_Tabl; //    ⮫殢
 //  ⠭
 MODE SAVE,COLORS,MODIFY,PRINT,SEARCH,FILTER;
 char far *EDIT; // ஢/  [itemsx]
 // 0x00 - , 0x01 - 뢠 , 0x02 - ।
 TEXT_FUN2 Text_Func, // 㭪 뢮 ࠭
  Item_Func; // 㭪 ࠡ⪨  ࠭
 FUN Init_Func; // .- 樠樨 
};

struct FIELD { //    뢮  ⨯ WINDOW
// int minx,miny,maxx,maxy; // ࠭ 
 int sx,sy,ex,ey;         //  뢮
 int metx;long mety;int endx;long endy; // 砫  ᫥  ࠭
 int locx,locy; // 騥  ࠭
 int sizey,onpagex,onpagey; //    ᫮ -⮢  ࠭
 long Y0, Y1, YN; // 砫 ,ࢠ   ,  
 COLOR far Col[8];
 // Panel_color,Field_color,Text_color,Rec_color,
 // Line_color,Axis_color,Hot_color,Head_Color;
};

/*typedef*/ struct dbfheader {
 char Ver;     //xxxx xx11 -  (0x03)
               //xxxx x1xx -   
               //1xxx xxxx - 稥 DBT-䠩
 char Date[3]; //   ଠ 
 long int Zap;  // ᫮ ᥩ   (0 - 1 000 000 000)
 int HeadLen; //   筮 ,=
                  //  =32+32*n,n-᫮ ᠭ 
 int ZapLen;  // , (0 - 4000)
 char Res1[2];    //१ࢨ஢
 char Per,Code;   //ਧ 뫮  ஢
 char ResNet[12]; //१ࢨ஢  ⥩
 char Mdx;        //稥 MDX-䠩 (0x01)
 char Res2[3];    //१ࢨ஢
}; // 32 

/*typedef*/ struct dbffield {
 char Name[11];   // ASCII- 
 char Type;       // ACSII-⨯  (C,N,F,L,D,M=
                  //                 =0x43,0x4E,0x46,0x4C,0x44,0x4D)
 char Addr[4];    //    
 char Len;        //  , ( 0 - 255 )
 char Dec;        // -  ᫥ ⮩,  ( Dec<Len )
 char Res1[2];    // १ࢨ஢  .⥬
 char Area;       // 䨪 ࠡ祩 
 char Res2[2];    // १ࢨ஢  .⥬
 char SetField;   // १ࢨ஢  ணࠬ SET FIELDS
 char Res3[8];    //  १ࢨ஢
}; // 32 

struct dbffile {
 char far *Name; // 䠩
 FILE far *fp;   // ਯ
 char Cond; //  ﭨ
 // xxxx xxx1 - 䠩  
 // xxxx xx1x - ⥪  㤠
 // xxxx x1xx -  ᯮ짮    
 //             (. 㪠⥫ Other_Hdr  楫 Max_Hdr_Line)
 // xxxx 1xxx -  뢠 㭪 ;  樠஢ 䠩
 long int Zap;   //᫮ ᥩ
 int Field;  //᫮ 
 long int Beg; // ⥫  ⥪ 
 int ZapLen,HeadLen; //   ,..
 char far *Names, far *Types;
  // Names -  12 ᨬ   , 
 int far *Lens, far *Decs;    //  ,᫮ .᫥ ⮩;
 char far *buffer; // ⥪ 
};


//         
void Chan_Block_Xor( BLOCK far *, COLOR, MODE );    //   . XOR
void Chan_Block( int, int, int, int, COLOR,
                 MODE );                       // 梥 
                                               //ࠦ  樥 XOR
void Set_Graph_Sim( void );                    //⠭ ᪨ ᨬ.
void Back_Graph_Sim( void );                   //⠭. ० ᨬ
void Chand( int, int, int, int, COLOR, MODE ); //ந.  

void Print( int, int, COLOR, COLOR, char far * );   //⭮ 뢮 ⥪
void Gprintf( int, int, char far *, ... );         //ଠ஢ 뢮 ⥪-
					       //  ᪨ ࠭
// void Fprintf (char *,char *, ... );
void Fun_Bar( char far *str );                     //뢮 ப 㭪樮
					       //
//void Status ( int ,int , char * );
MODE Find_Key( char far *str, char sim );          //  ᨬ

void Common_Menu( CASE far *, CASE far *, MODE );        //뢮  ᪠,
                                               //訡, ।०
void Close_System( void );                     //⨥  ⥬,
                                               //䠩, 室  ணࠬ
void Menu_Deis( void );                        //ࠡ⪠  ⢨
void Init_Case_Wnd( VID far *wnd, CASE far *fn,        // 筮 롮
		    MODE far *point );
void Case_Wnd( MENU far *, CASE far * );                 // 筮 롮
void Case_Wnd_Text( MENU far *, CASE far *, CASE far * );     // 筮 롮 
					       //⥪⮢  
void Menu_Wnd( MENU far *wnd, CASE far *fn,            //믠饥 
	       MODE &point );
void Message_Text( CASE far * );                    //뢮 ᮮ饭
void Help_Text( HELP far *);
void Sound( int, int );                        //ந 㪠  
void Nop( void );                              //誠
char Answ_Menu( CASE far *fn );
void Geting_Text( MENU far *, CASE far *, char far * );
void Get_Many_Text( VIDI far *, CASEI far *);
char Get_Ich_Text( CASEI far *, char );

//void Locate( char kol, char strok, char page );
void Init_System( void );              //樠  ०

void Graphics( void );
void Process_Graphics( void );

// Hot keys and service functions:
void Clr_Scr (void);
void Esc_Key (void);
void Good_Sound (void),Bad_Sound (void);
void Ret_In_Dos( void );
void Help(void);
void Mistake (int);
void About (void);
int strlen0 (char far *);
void strset0 (char far *,int);
void strcat0 (char far *,const char far *);
int scan_by_key (char *);

// 㭪樨  ࠡ⪨  ⢨
void Exit( void );
void huge Pch( void );
void huge Nod( void );
void huge N_( void  );
void Menu_1 (int Point);
void Normal (void);
void Regul (void);
void Vybor(void);
void One_Per(void);
void All_Per(void);
void Auto(void);
void Input(void);
void Schet(void);
void IndexHelp (void);
// 㭪樨 ࠡ⪨ :
void Select_Index (void);
void Window (WINDOW *,FIELD *);
void Show_1(int,int,int,long);
void Item_1(int,int,int,long);
//void Goto_Number (void);
void What_Number (void);
void Key_Search (void),All_Search (void);
void Show_DB(int,int,int,long);
void Item_DB(int,int,int,long);
void Info_DB(void);

int GraphMenu(char far *menu_title,char far * far *menu_item_list,
    int page_left,int page_top,int page_cols,int page_rows,int);
float fabs_(float);
/////////////////////////////////////////////////////////////
void Vedomost(void);
void Demo_1 (void);
int Prn_Status(void);  // ⮢ ਭ

//////////////////////////  ""
char Fun_Bar_Keys (char ,KEY *,int *);
int Init_Mouse(void); void ms_state(void); void ms_move(int, int);
void set_graph_cursor(int, int, unsigned int far *); int ms_release(void);
void CURSOR_ON(void); void CURSOR_OFF(void);
char Mouse_In_Field (int X1, int Y1, int Xsize, int Ysize,
 int Xnum, int Ynum, int Xdop, int Ydop, int Color, int *I, int *J);
char AnyClick (void);
#endif
